<?php

error_reporting(E_ALL);
require_once("cabecera.inc.php"); 
require_once("db.inc.php"); 
require_once("mime.inc.php");


// Extrae el valor de un parmetro POST
// En caso de no existir, devuelve ""
function parametro($nombre) {
	return isset($_POST[$nombre]) ? $_POST[$nombre] : "" ;
}

// Comprobar si se han recibido datos del formulario
if (isset($_POST["destino"])) {
	// Obtener los valores del formulario
	$destino = parametro("destino");
	$asunto = parametro("asunto");
	$texto = parametro("texto");
	$enlace = parametro("enlace");
	$mime = parametro("mime");

		
	// Insertar mensaje en la base de datos
	consulta(<<<EOT
		insert into mensajes(remitente, destino, asunto, texto, enlace, nombre_adjunto, mime_adjunto)
		values 
		($_SESSION[id_usuario], $destino, '$asunto', '$texto', '$enlace', '', '')
EOT
	);
		
	// Subir fichero
// 	if (isset($_FILES["fichero"]) && $_FILES["fichero"]["error"] != UPLOAD_ERR_NO_FILE) {
	if (isset($_FILES["fichero"])) {
		// El nombre del fichero ser el ID del mensaje en la tabla y estar en el directorio "uploads"
		$id_mensaje = id_insertado();
		$ruta_archivo = "uploads/" . $id_mensaje;

		// Nombre del fichero enviado
		$nombre_fichero = $_FILES["fichero"]["name"] ;

		// Informar del estado de la subida en caso de error
		if ($_FILES["fichero"]["error"]>0) {
			$upload_errors = array( 
                            UPLOAD_ERR_OK        => "OK.", 
                            UPLOAD_ERR_INI_SIZE    => "Superado upload_max_filesize.", 
                            UPLOAD_ERR_FORM_SIZE    => "Superado el MAX_FILE_SIZE del formulario.", 
                            UPLOAD_ERR_PARTIAL    => "Subida no completada.", 
                            UPLOAD_ERR_NO_FILE        => "Sin fichero.", 
                            UPLOAD_ERR_NO_TMP_DIR    => "Falta directorio temporal.", 
                            UPLOAD_ERR_CANT_WRITE    => "Imposible escribir a disco.", 
                            UPLOAD_ERR_EXTENSION     => "Extensi&oactue;n no permitida.", 
                        );

			print "ERROR en Fichero: " . htmlentities($upload_errors[$_FILES["fichero"]["error"]]) . "<br>";
		} else {
                    // Mover el fichero a su ubicacin final
                    move_uploaded_file($_FILES["fichero"]["tmp_name"], $ruta_archivo);
                    // Determinar el tipo mime si no lo proporciona el usuario
                    if (trim($mime) == "") {
                        if (isset($_FILES["fichero"]["type"])) {
                            $mime = $_FILES["fichero"]["type"];
                        } else {
                            $mime = tipo_mime($ruta_archivo);
                        }
                    }
                    
                    // Actualizar la informacin del mensaje
                    consulta(<<<EOT
                            update mensajes 
                            set
                                    nombre_adjunto = '$nombre_fichero',
                                    mime_adjunto = '$mime'
                            where id = $id_mensaje
EOT
                    );
                }
	}

	
	print "<h3>Mensaje Enviado</h3>";	
}
?>

<script>
	function carga_descripcion() {
		ruta = window.location.href;
		
		tdescripcion = ruta.split("?")[1];
		if (tdescripcion) {
			document.getElementById("descripcion").innerHTML = decodeURIComponent(tdescripcion);
		}
	}
</script>

<body onload="carga_descripcion()">
<h1 id="descripcion">&nbsp;</h1>
<form method="POST" enctype="multipart/form-data">
	<table>
		<tr><td>Destino:</td>
			<td>
				<select id="destino" name="destino">
				<?php
					// Lista los usuarios como opciones del select
					$res = consulta("select id, nombre from usuarios");
					$n = numero_de_filas($res);
					for ($i=0; $i<$n; $i++) {
						$fila = fila($res, $i);
						print "<option value='$fila[id]'>$fila[nombre]</option>";
					}
				?>
				</select>
			</td>
		</tr>
		<tr><td>Asunto:</td><td><input type="text" id="asunto" name="asunto" size="40"></td></tr>
		<tr><td>Texto:</td><td><input type="text" id="texto" name="texto" size="90"></td></tr>
		<tr><td>Enlace (URL):</td><td><input type="text" id="enlace" name="enlace" size="90"></td></tr>
		<tr><td>Fichero:</td><td><input type="file" id="fichero" name="fichero"></td></tr>
		<tr><td>Forzar tipo MIME:</td><td><input type="text" id="mime" name="mime"></td></tr>
		<tr><td>&nbsp;</td><td><input type="submit" value="Enviar"></td></tr>
	</table>
</form>
</body>