<?php
//header("X-Frame-Options: Deny");

/* EJEMPLO DE PROTECCIN ANTI CSRF USANDO OWASP CSRFPROTECTOR

require_once(__DIR__ . "/csrfp/libs/csrf/csrfprotector.php");
csrfProtector::init();
*/ 

// Se bloquean las cuentas por sobrepasar cierto nmero de errores de login?
$bloqueo_por_errores = false;

// Nmero mximo de errores de login permitidos
$errores_bloqueo = 10;

// Funciones para redirigir a otras pginas
require_once("redirigir.inc.php");

// Acceso a la Base de Datos
require_once("db.inc.php");

// Usar sesiones de PHP. No es necesario si se usa CSRFPROTECTOR
session_start();

// Ruta de instalacin de la app
$carpeta_instalacion = preg_replace('/(.*\/).*/','${1}',$_SERVER["PHP_SELF"]);

// URL de destino si las credenciales son correctas
if (isset($_GET["url"])) {
	$destino = $_GET["url"];
} else {
	$destino = $carpeta_instalacion . "principal.php";
}

// Se han introducido credenciales correctas ?
$login_correcto = false;

// Si se ha rellenado anteriormente el formulario, comprobar los datos
if (isset($_POST["nombre"])) { 
	// Sentencia SQL a ejecutar
    $sql = "select * from usuarios where nombre = '" .
		$_POST["nombre"] .
		"' and pwd = '" .
		$_POST["pwd"] . "'" ;

	// Ejecuta la consulta
    $resultado = consulta($sql);

    // Si hay filas, los datos de acceso eran correctos
    if (numero_de_filas($resultado) != 0) {
		// Obtener los datos del usuario logado
		$fila = fila($resultado, 0);
		
		// Comprobar si el usuario est bloqueado
		if (! $bloqueo_por_errores or $fila["errores"] < $errores_bloqueo) {
			// Todo OK
			$login_correcto = true;
				
			// Resetear cuenta de errores
			consulta(
				"update usuarios set errores = 0 where nombre = '" .
				$_POST["nombre"] .
				"'"
			);

			// Almacenar su ID y nombre en los datos de la sesin
			$_SESSION["id_usuario"] = (int)$fila["id"];
			$_SESSION["nombre_usuario"] = $fila["descr"];
			$_SESSION["admin"] = $fila["admin"];

			// Redirigir a pgina de destino
			// "Asegurndose" de que la ruta hace referencia al mismo servidor
			redirige("http://" . $_SERVER['SERVER_NAME'] . $destino);
		} else {
			print "USUARIO BLOQUEADO";
		}
	}
}

// Si no se ha iniciado la sesin, mostrar un formulario de logon
if (! $login_correcto) {
	// Incrementar cuenta de errores de acceso para el usuario
	if (isset($_POST["nombre"]) and $bloqueo_por_errores) {	
		$sql = "update usuarios set errores = errores + 1 where nombre = '" .
			$_POST["nombre"] .
			"' and errores < " .
			$errores_bloqueo;

		consulta($sql);
	}
	
	?>
	<!DOCTYPE html>
	<html>
	<head><title>Login</title></head>
	<body>
	<h1>Acceso al sistema de comunicaciones</h1>
	<form method="POST" autocomplete="on"
				action="login.php?url=<?php print $destino; ?>">
		<table>
		<tr><td colspan="2">Introduzca sus datos de acceso</td></tr>
		<tr>
			<td>Nombre:&nbsp;</td>
			<td><input type="text" name="nombre" id="nombre"></td>
		</tr>
		<tr>
			<td>Clave:&nbsp;</td>
			<td><input type="password" name="pwd" id="pwd"></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td style="text-align:right">
				<input type="submit" value="Enviar">
			</td>
		</tr>
		</table>
		<p />
	</form>
	</body>
	</html>
	<?php
}

?>