<?php
include("sesion.inc.php");
include("db.inc.php");

// Determinar qué se pide...
$orden = isset($_GET["orden"]) ? $_GET["orden"] : "formulario";

// ... y actuar en consecuencia
switch ($orden) {
	case "formulario";
		include("cabecera.inc.php");
		formulario();
		break;
	case "lista_mensajes":
		lista_mensajes();
		break;
	case "carga_mensaje":
		if (isset($_GET["id"])) {
			carga_mensaje($_GET["id"]);
		} else {
			print "Se necesita identificador de mensaje";
		}
		break;
	case "borra_mensaje":
		if (isset($_GET["id"])) {
			borra_mensaje($_GET["id"]);
		} else {
			print "Se necesita identificador de mensaje";
		}
		break;
}


// Lista los mensajes del usuario actual
function lista_mensajes(){
	$res = consulta(<<<EOT
		select mensajes.id as id, usuarios.nombre as remite, asunto
		from mensajes, usuarios
		where destino = $_SESSION[id_usuario]
		and mensajes.remitente = usuarios.id
EOT
	);
	
	// Número de mensajes obtenidos
	$n = numero_de_filas($res);
	
	// Tabla usada para formatear los datos
	print "<table style='width:100%'>";
	print "<tr><td>REMITENTE</td><td>ASUNTO</td><td>ACCIONES</td></tr>";
	
	// Mostrar el resumen de cada mensaje, asociando las acciones de
	// cargar en el panel de detalle y de eliminar
	for ($i=0; $i<$n; $i++) {
		$reg = fila($res, $i);
		
		print <<<EOT
		<tr>
			<td onclick="carga_mensaje('$reg[id]')" style="width:33%;border:solid">
				$reg[remite]
			</td><td onclick="carga_mensaje('$reg[id]')"  style="width:33%;border:solid">
				$reg[asunto]
			</td><td>
				<button onclick="borra_mensaje('$reg[id]')">
					Borrar
				</button>
			</td>
		</tr>
EOT;
	}
	
	print "</table>";
}


// Proporciona la información de detalle de un mensaje
// Parámetro: $id -> id del mensaje
function carga_mensaje($id) {
	// Obtener el registro
	$res = consulta(<<<EOT
		select mensajes.id as id, usuarios.descr as remite, asunto, texto, enlace, nombre_adjunto, mime_adjunto 
		from mensajes, usuarios
		where mensajes.id = $id
		and mensajes.remitente = usuarios.id		
EOT
	);

	// Formatear los datos
	if (numero_de_filas($res) > 0) {
		$resultado = fila($res, 0);
		
		// Formatear el enlace
		$enlace = (trim($resultado["enlace"]) != "") ?
			"<a target='_blank' href='$resultado[enlace]'>$resultado[enlace]</a>"
			:
			"&nbsp;"
		;
                
		// Formatear la información sobre el fichero
		if (trim($resultado["nombre_adjunto"]) != "") {
			$inicio = "<a href='descarga_adjunto.cgi?id=$id&cabeceras[]=Content-type: $resultado[mime_adjunto]";
			
			$final_descargar = '&cabeceras[]=Content-Disposition: attachment%3B filename="' . $resultado["nombre_adjunto"] . '"';
			$final_abrir = '';
			
			$fichero = $inicio . $final_abrir . "' target='_blank'>Abrir $resultado[nombre_adjunto]</a><br>" .
						$inicio . $final_descargar. "' >Descargar $resultado[nombre_adjunto]</a><br>" ;
		} else {
			$fichero = "&nbsp;";
		}
		
                // Generar la salida
                print <<<EOT
                    <div id="id" style="display:none">$resultado[id]</div>
                    <h1 style="background-color:lightblue;text-align:center">
                            ASUNTO: $resultado[asunto]
                    </h1>
                    <h2 style="background-color:lightgreen;text-align:center">
                            REMITENTE: $resultado[remite]
                    </h2>
                    <br>TEXTO:<br><br>
                            $resultado[texto]
                    <br><br>
                    <table style="border:solid;width:100%">
                            <tr>
                                <td style="text-align:right">
                                    Enlace:
                                </td><td>
                                    $enlace
                                </td>
                            </tr><tr>
                                <td style="text-align:right">
                                    Fichero:
                                </td><td>
                                    $fichero
                                </td>
                            </tr>
                    </table>
EOT;

	} else {
		print "<h3>Mensaje no encontrado</h3>";
	}
}


// Borra un mensaje y muestra la lista de los mensajes restantes
// Parámetro: $id -> id del mensaje a borrar
function borra_mensaje($id) {
	consulta("delete from mensajes where id = $id");
	lista_mensajes();
}

// Muestra el formulario de la parte cliente
// Para evitar confusiones, las funciones JavaScript que realizan peticiones 
// tienen el mismo nombre que sus contrapartidas en la parte servidora
function formulario() {
	print <<<EOT
		<script>
			// Crea un objeto para realizar peticiones HTTP
			function crea_peticion() {
				var peticion;
				
				if (window.XMLHttpRequest) {
					// IE7+, Firefox, Chrome, Opera, Safari
					peticion = new XMLHttpRequest();
				} else {
					// IE6, IE5
					peticion =new ActiveXObject("Microsoft.XMLHTTP");
				}
				return peticion;
			}

			// Pide la lista de mensajes y la muestra en pantalla
			function lista_mensajes() {
				// Preparar petición XMLHTTPRequest
				peticion = crea_peticion();
				
				// Acciones a realizar cuando se reciba respuesta
				peticion.onreadystatechange = function () {
					if (peticion.readyState==4 && peticion.status==200) {
						document.getElementById("lista").innerHTML = peticion.responseText;
					}
				}
				
				// Enviar petición
				peticion.open("GET", "mensajes.php?orden=lista_mensajes", true);
				peticion.send();
			
			}
			
			// Pide los datos de un mensaje y los muestra en pantalla
			function carga_mensaje(id) {
                                document.getElementById("mensaje_actual").src = 
                                    "mensajes.php?orden=carga_mensaje&id=" + id;
			}
			
			// Borra un mensaje y recarga la lista de mensajes
			function borra_mensaje(id) {
				// Preparar petición XMLHTTPRequest
				peticion = crea_peticion();
				
				// Acciones a realizar cuando se reciba respuesta
				peticion.onreadystatechange = function () {
					if (peticion.readyState==4 && peticion.status==200) {
						document.getElementById("lista").innerHTML = peticion.responseText;
						
						// Si el mensaje mostrado en el detalle era el borrado, limpiar la pantalla
						if (document.getElementById("id").innerHTML == id) {
							document.getElementById("asunto").innerHTML = '&nbsp';
							document.getElementById("remite").innerHTML = '&nbsp';
							document.getElementById("texto").innerHTML = '&nbsp';
							document.getElementById("enlace").innerHTML = '&nbsp';
							document.getElementById("fichero").innerHTML = '&nbsp';
							document.getElementById("id").innerHTML = '&nbsp';
						}
					}
				}
				
				// Enviar petición
				peticion.open("GET", "mensajes.php?orden=borra_mensaje&id=" + id, true);
				peticion.send();	
			}
		</script>
		
		<html>
		<head><title>Panel de Mensajes</title></head>
		<body onload="lista_mensajes()">
			<h1>Mensajes Recibidos</h1>
			<p><a href="envia_mensaje.php?Componer Mensaje"
					target="_blank">Escribir un mensaje</a></p>
			<p />
			<table style="width:100%;height:60%">
				<tr>
					<td style="border:solid;width:30%;vertical-align:top">
						<div style="background-color:lightblue">Mensajes</div>
						<div id="lista">&nbsp;</div>
					</td>
					<td style="border:solid;width:70%;vertical-align:top">
                                            <iframe id="mensaje_actual" 
                                                style="width:100%;height:100%">
                                            </iframe>
					</td>
				<tr>
			</table>
			<button onclick="lista_mensajes()">Recargar</button>
		</body>
		</html>
EOT;
}

?>