<?php
// Formas de redirigir a otras pginas

// Usando etiqueta META
function redirige_meta($destino,  $delay) {
?>
    <html>
            <head>
                    <meta http-equiv="Refresh" 
                        content="<?php print $delay ?>;url=<?php print $destino; ?>">
            </head>
            <body></body>
    </html>
    <?php
}

// Mediante scripting
function redirige_script($destino, $delay) {
    if ($delay > 0) {
        ?>
            <script type="text/javascript">
                setTimeout(function() {
                        window.location = "<?php print $destino; ?>";
                    },
                    <?php print $delay; ?>
                );
            </script>           
        <?php
    } else {
        ?>
            <script type="text/javascript">
                window.location = "<?php print $destino; ?>";
            </script>   
        <?php
    }
}

// Mediante scripting, tras carga de documento
function redirige_script_onload($destino, $delay) {
    ?>
        <script type="text/javascript">
            function ir() {
    <?php
    
    if ($delay > 0) {
        ?>
                setTimeout(function() {
                        window.location = "<?php print $destino; ?>";
                    },
                    <?php print $delay; ?>
                );
        <?php
    } else {
        ?>
                window.location = "<?php print $destino; ?>";
        <?php
    }
    ?>
            }
        </script>
        <html><body onload="ir()"></body></html>

    <?php
}


// Mediante cabecera - HTTP 302 - Temporal
function redirige_cabecera_temporal($destino) {
    header("Location: $destino");
}

// Mediante cabecera - HTTP 301 - Permanente
function redirige_cabecera_permanente($destino) {
    header("HTTP/1.1 301 Moved Permantly");
    header("Location: $destino");
}

// Mediante cabecera - Refresh
function redirige_refresh($destino, $delay) {
    header("Refresh: $delay ;url=$destino");
}


// Redireccin a utilizar por la aplicacin
function redirige($destino) {
    $tipo = isset($_GET['redir_tipo']) ? $_GET['redir_tipo'] : "";
    
    switch ($tipo) {
        case "script":
            $delay = 1000 * (isset($_GET['redir_delay']) ? (int)$_GET['redir_delay'] : 0);
            redirige_script($destino, $delay);
            break;
        case "script_onload":
            $delay = 1000 * (isset($_GET['redir_delay']) ? (int)$_GET['redir_delay'] : 0);
            redirige_script_onload($destino, $delay);
            break;
        case "meta":
            $delay = isset($_GET['redir_delay']) ? (int)$_GET['redir_delay'] : 1;
            redirige_meta($destino, $delay);
            break;
        case "refresh":
            $delay = isset($_GET['redir_delay']) ? (int)$_GET['redir_delay'] : 1;
            redirige_refresh($destino, $delay);
            break;
        case "301":
            redirige_cabecera_permanente($destino);
            break;
        default:
            redirige_cabecera_temporal($destino);
            break;
    }
    
}
?>