<?php 

if (isset($_GET['url'])) {
    $url = $_GET['url'];
} else {
    exit;
}

$datosURL = parse_url($url);
if (! $datosURL) {
    exit;
}



function normalizaURL($url, $urlBase) {
    if (preg_match("/^(mailto:|javascript:|vbscript:)/i", $url)) {
        return $url;
    }
    
    
    $datos = parse_url($url);
    $base  = parse_url($urlBase);
    if (! isset($base['path'])) {
        $base['path'] = "/";
    }

    if (!isset($datos["scheme"])) {
        $datos["scheme"] = $base["scheme"];
        $datos["host"] = $base["host"];
        
        if (!isset($datos["path"])) {
            $datos["path"] = $base["path"];
        } else if (strpos($datos["path"], "/") !== 0) {
            $datos["path"] = preg_replace("/[^\/]*$/", "", $base["path"]) . $datos["path"];
        }
    }
    
    $normalizada = $datos['scheme'] . "://" . $datos['host'];
    if (isset($datos['path'])) {
        $normalizada = $normalizada . $datos['path'];
    }
    if (isset($datos['query'])) {
        $normalizada = $normalizada . "?" . $datos['query'];
    }
    if (isset($datos['fragment'])) {
        $normalizada = $normalizada . "#" .$datos['fragment'];
    }

    return $normalizada;
}

function extension($url) {
    if (preg_match("/^(mailto:|javascript:|vbscript:)/i", $url)) {
        return "";
    }
    
    $datos = parse_url($url);
    
    if (isset($datos['path'])) {
        $datos = pathinfo($datos['path']);
        if (isset($datos['extension'])) {
            return $datos['extension'];
        }
    }
    
    return "html";

}



function extensionPedida() {
    global $datosURL;

    if (! isset($datosURL['path'])) {
        return "html";
    }
    
    if (preg_match("/[^\.]*$/", $datosURL['path'], $match)) {
        return $match[0];
    } else {
        return "html";
    }
}

function transfierePeticion() {
    global $url;

    $cabecerasPeticion = getallheaders();

    $cabecerasEnvio = [];
    foreach ($cabecerasPeticion as $nombre => $valor) {
        if (trim($nombre) == "Host") {
            continue;
        }
        $cabecerasEnvio[] = trim($nombre) . ": " . trim($valor);
    }

    $metodo = $_SERVER['REQUEST_METHOD'];



    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_HEADER, true);
    curl_setopt($curl, CURLOPT_HTTPHEADER, $cabecerasEnvio);
    curl_setopt($curl, CURLOPT_ENCODING, "");
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST , false);
        
    if ($metodo=="POST") {
        curl_setopt($curl, CURLOPT_POST, true);
        
        $cuerpoPeticion = file_get_contents('php://input');
        curl_setopt($curl, CURLOPT_POSTFIELDS, $cuerpoPeticion);
    }

    $resultado = curl_exec($curl);
    $tamanoCabeceras = curl_getinfo($curl, CURLINFO_HEADER_SIZE);

    curl_close($curl);

    return [
        'cabeceras' => preg_split("/((\r?\n)|(\r\n?))/", trim(substr($resultado, 0, $tamanoCabeceras))),
        'cuerpo' => substr($resultado, $tamanoCabeceras)
    ];
}





function cambiaURL($atributo) {
    global $url;
    $nuevaURL = $atributo[count($atributo) - 1]; 
    $nuevaURL = "curl.php?url=" . urlencode(normalizaURL($nuevaURL, $url));

    if (count($atributo)==3) {
        return $atributo[1] . ": " . $nuevaURL;
    } else  {
        return $atributo[1] . "=" .  $atributo[2] . $nuevaURL . $atributo[2];
    }    
}

function respuestaCuerpo($recibido) { 
    global $url;

    if (! in_array(extension($url), ['html', 'htm', 'php'])) {
        print $recibido['cuerpo'];
        return;
    }

    $modificado = preg_replace_callback("/(href|src|action)=(')([^']*)'/i", "cambiaURL", $recibido['cuerpo']);
    $modificado = preg_replace_callback('/(href|src|action)=(")([^"]*)"/i', "cambiaURL", $modificado);
    $modificado = preg_replace("/target=[\"']_blank[\"']/i", "", $modificado);
    print $modificado;
    
    $base = str_replace('"', '\"', $url);
    print str_replace("<<<BASE>>>", $base, file_get_contents("anadir.html"));
}

function respuestaCabeceras($recibido) {
    $ignorar = [
        "content-encoding:", "x-frame-options:",
        "content-security-policy:"
    ];
    $regexIgnorar = "/^" . join("|", $ignorar) . "/i";
    foreach($recibido["cabeceras"] as $cabecera) {
    
        if (! preg_match($regexIgnorar, $cabecera)) {
            header(preg_replace_callback("/^(location):\s*(.*)$/i", "cambiaURL", $cabecera));
        }
    }
    
}


$recibido = transfierePeticion();
respuestaCabeceras($recibido);

respuestaCuerpo($recibido);

?>
